"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const postcss_1 = __importDefault(require("postcss"));
function generateCompatibilityCSS(theme, usages) {
    const root = postcss_1.default.root();
    for (const usage of usages) {
        root.append(postcss_1.default.rule({
            selectors: usage.selectors,
            nodes: [
                postcss_1.default.decl({
                    prop: usage.property,
                    value: 
                    // @todo handle contextual properties and multiple `cfg()` per decl
                    theme.contextless[usage.key] || usage.originalValue
                })
            ]
        }));
    }
    return root;
}
exports.generateCompatibilityCSS = generateCompatibilityCSS;
